GCC Bugzilla has been upgraded from version 4.4.9 to 5.0rc3. If you see any problem, please report it to bug 64968.
Bug 15798 - Bug box in Gigi, code=201, on legal program with tasking
Summary: Bug box in Gigi, code=201, on legal program with tasking
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: ada (show other bugs)
Version: 3.4.0
: P2 minor
Target Milestone: 4.6.1
Assignee: Not yet assigned to anyone
URL:
Keywords: ice-on-valid-code
Depends on:
Blocks:
 
Reported: 2004-06-03 19:07 UTC by Ludovic Brenta
Modified: 2011-08-31 07:05 UTC (History)
4 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2007-12-13 14:00:19


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ludovic Brenta 2004-06-03 19:07:58 UTC
(Debian bug #246185)

with unchecked_conversion;
procedure Test_246185 is
   task type T;
   function convert is new unchecked_conversion(T, integer);
   task body T is
   x: integer := convert(T);
   begin
      null;
   end T;
begin
   null;
end Test_246185;


+===========================GNAT BUG DETECTED==============================+
| 3.4.0 (Debian) (i486-pc-linux-gnu) Gigi abort, Code=201                  |
| Error detected at test_246185.adb:6:26                                   |
| Please submit a bug report; see http://gcc.gnu.org/bugs.html.            |
| Include the entire contents of this bug box in the report.               |
| Include the exact gcc-3.4 or gnatmake command that you entered.          |
| Also include sources listed below in gnatchop format                     |
| (concatenated together with no headers between files).                   |
+==========================================================================+

Please include these source files with error report
Note that list may not be accurate in some cases, 
so please double check that the problem can still 
be reproduced with the set of files listed.

test_246185.adb

compilation abandoned
gnatmake: "test_246185.adb" compilation error
Comment 1 Andrew Pinski 2004-10-12 03:56:29 UTC
Confirmed, a different error on the mainline:
gimplification failed:
test_246185__t <type_decl 0x42e7f980 test_246185__t
    type <record_type 0x42e44f80 test_246185__t type_2 BLK
        size <integer_cst 0x42e0e720 constant invariant 32>
        unit size <integer_cst 0x42e0e360 constant invariant 4>
        align 32 symtab 0 alias set -1
        fields <field_decl 0x42e7cf80 _task_id type <pointer_type 0x42e46580 
system__tasking__task_id>
            unsigned nonaddressable SI file test_246185.adb line 3 size <integer_cst 0x42e0e720 32> unit 
size <integer_cst 0x42e0e360 4>
            align 32 offset_align 128
            offset <integer_cst 0x42e0e380 constant invariant 0>
            bit offset <integer_cst 0x42e0eee0 constant invariant 0> context <record_type 0x42e44f80 
test_246185__t> arguments <integer_cst 0x42e0e380 0>> Ada size <integer_cst 0x42e0e720 32>
        pointer_to_this <pointer_type 0x42e46100 test_246185__T1b> reference_to_this <reference_type 
0x42e7f100> chain <type_decl 0x42e7f000>>
    VOID file test_246185.adb line 3
    align 1 context <function_decl 0x42e44900 test_246185> chain <type_decl 0x42e7fa00 
test_246185__convertGP80__source>>
+===========================GNAT BUG 
DETECTED==============================+
| 4.0.0 20041008 (experimental) (powerpc-apple-darwin7.4.1) GCC error:     |
| gimplification failed                                                    |
| Error detected at test_246185.adb:12:5                                   |
| Please submit a bug report; see http://gcc.gnu.org/bugs.html.            |
| Include the entire contents of this bug box in the report.               |
| Include the exact gcc or gnatmake command that you entered.              |
| Also include sources listed below in gnatchop format                     |
| (concatenated together with no headers between files).                   |
+==============================================================
============+
Comment 2 Arnaud Charlet 2005-09-06 13:36:27 UTC
Program has no semantic meaning, so lowering severity.
Comment 3 Samuel Tardieu 2007-12-13 14:00:19 UTC
gimplification failed:
test_246185__t <type_decl 0xb7c1dbc8 test_246185__t
    type <record_type 0xb7bf0f70 test_246185__t sizes-gimplified type_2 BLK
        size <integer_cst 0xb7bcd620 constant invariant 32>
        unit size <integer_cst 0xb7bcd40c constant invariant 4>
        align 32 symtab 0 alias set -1 canonical type 0xb7bf0f70
        fields <field_decl 0xb7c1c564 _task_id type <pointer_type 0xb7bf30d0 system__tasking__task_id>
            unsigned nonaddressable SI file test_246185.adb line 3 col 4 size <integer_cst 0xb7bcd620 32> unit size <integer_cst 0xb7bcd40c 4>
            align 32 offset_align 128
            offset <integer_cst 0xb7bcd94c constant invariant 0>
            bit offset <integer_cst 0xb7bcd968 constant invariant 0> context <record_type 0xb7bf0f70 test_246185__t>> Ada size <integer_cst 0xb7bcd620 32>
        pointer_to_this <pointer_type 0xb7c1dea0 test_246185__T1b> reference_to_this <reference_type 0xb7c1d820> chain <type_decl 0xb7c1d750 test_246185__tV>>
    VOID file test_246185.adb line 3 col 14
    align 1 context <function_decl 0xb7bf1230 test_246185> chain <type_decl 0xb7c1dc30 test_246185__convertGP80__source>>
+===========================GNAT BUG DETECTED==============================+
| 4.3.0 20071213 (experimental) (i686-pc-linux-gnu) gimplification failed  |
| Error detected around test_246185.adb:6                                  |
Comment 4 Ludovic Brenta 2008-12-30 10:42:17 UTC
Jörgen Tegnér reports:

gnatmake test_41.adb 
gcc-4.3 -c test_41.adb
+===========================GNAT BUG DETECTED==============================+
| 4.3.2 (i486-pc-linux-gnu) in gimplify_expr, at gimplify.c:6314           |
| Error detected around test_41.adb:6                                      |
Comment 5 Ludovic Brenta 2009-08-06 20:33:01 UTC
Xavier Grave reports:

+===========================GNAT BUG DETECTED==============================+
| 4.4.1 (i486-pc-linux-gnu) GCC error:                                     |
| in get_expr_operands, at tree-ssa-operands.c:2072                        |
| Error detected around test_41.adb:12                                     |
...
raised TYPES.UNRECOVERABLE_ERROR : comperr.adb:424
gnatmake: "test_41.adb" compilation error
Comment 6 nicolas.boulenguez 2011-08-31 00:10:37 UTC
fixed in 4.6.1
Comment 7 Arnaud Charlet 2011-08-31 07:05:33 UTC
Closing then